/******************************************************************************/
/*!
 * \file timlUtilVectorSortIndexFloat.c
 */
/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************/

/*******************************************************************************
 *
 * INCLUDES
 *
 ******************************************************************************/

#include "../api/timl.h"
#ifdef TIML_ALT
#include "../../alt/util/timlUtilAlt.h"
#endif


inline int timlUtilSortCompareFloatPointer(const void * a, const void * b)
{
   if (**(const float**) a < **(const float**) b) {
      return -1;
   }
   return **(const float**) a > **(const float**) b;
}


/******************************************************************************/
/*!
 * \ingroup    util
 * \brief      Sort an array in descending order and return the indices of the original elements in the sorted array
 * \param[in]  a     Array
 * \param[out] index Sorted index
 * \param[in]  n     Array size
 * \return     Error code
 */
/******************************************************************************/

int timlUtilVectorSortIndexFloat(float *a, int *index, int n)
{
#ifdef TIML_CPU
   int i;
   float **pArray;
   pArray = malloc(sizeof(float*) * n);
   for (i = 0; i < n; i++) {
      pArray[i] = &a[i];
   }
   qsort(pArray, n, sizeof(float*), timlUtilSortCompareFloatPointer);
   for (i = 0; i < n; i++) {
      index[i] = pArray[i] - a;
   }
   free(pArray);

   return 0;
#elif defined TIML_ALT
   return timlUtilFloatSortIndexAlt(a, index, n);
#endif
}

